#include "libmpeg2.h"
#include <stdlib.h>

#define BUFSIZE 1000000

int main(int argc, char *argv[])
{
	mpeg2_t *file;
	int i, result;
	unsigned char *output, **output_rows;
	float *audio_output_f;
	short *audio_output_i;

	if(argc < 2)
	{
		printf("Need an MPEG stream.\n");
		exit(1);
	}

	file = mpeg2_open(argv[1]);
	if(file)
	{
		fprintf(stderr, "Audio: %d\n", mpeg2_has_audio(file));
		fprintf(stderr, "  channels %d sample rate %d total samples %ld\n", mpeg2_audio_channels(file), 
			mpeg2_sample_rate(file),
			mpeg2_audio_samples(file));
		fprintf(stderr, "Video: %d\n", mpeg2_has_video(file));
		fprintf(stderr, "  width %d height %d frame rate %0.3f\n", mpeg2_video_width(file), 
			mpeg2_video_height(file), 
			mpeg2_frame_rate(file));
		fprintf(stderr, "  total frames %ld\n", mpeg2_video_frames(file));

		mpeg2_set_cpus(file, 1);
//		audio_output_f = malloc(BUFSIZE * sizeof(float));
//		audio_output_i = malloc(BUFSIZE * sizeof(short));
//		result = mpeg2_read_audio(file, audio_output_f, 0, 0, BUFSIZE);
//		result = mpeg2_read_audio(file, 0, audio_output_i, 1, BUFSIZE);
//		fwrite(audio_output_i, BUFSIZE, 1, stdout);

		output = malloc(mpeg2_video_width(file) * mpeg2_video_height(file) * 3);
		output_rows = malloc(sizeof(unsigned char*) * mpeg2_video_height(file));
		for(i = 0; i < mpeg2_video_height(file); i++)
			output_rows[i] = &output[i * mpeg2_video_width(file) * 3];
//		mpeg2_set_frame(file, 100);
// 		for(i = 0; i < 30; i++)
// 		{
			result = mpeg2_read_frame(file, output_rows, mpeg2_video_width(file), mpeg2_video_height(file), MPEG2_RGB888);
// 		}
//		mpeg2_set_frame(file, 92);
//			result = mpeg2_read_frame(file, output);

		mpeg2_close(file);
		free(output_rows);
		free(output);
	}
	return 0;
}
