#include "libmpeg2.h"
#include "mpeg2protos.h"

#include <stdlib.h>

mpeg2_atrack_t* mpeg2_new_atrack(mpeg2_t *file)
{
	mpeg2_atrack_t *new_atrack;
	new_atrack = malloc(sizeof(mpeg2_atrack_t));
	new_atrack->channels = 0;
	new_atrack->sample_rate = 0;
	new_atrack->total_samples = 0;
	new_atrack->current_position = 0;
	new_atrack->demuxer = mpeg2_new_demuxer(file, 1, 0);
	new_atrack->audio = mpeg2audio_new(file, new_atrack);
	return new_atrack;
}

int mpeg2_delete_atrack(mpeg2_t *file, mpeg2_atrack_t *atrack)
{
	mpeg2audio_delete(atrack->audio);
	mpeg2_delete_demuxer(atrack->demuxer);
	free(atrack);
}

